use crate::config::Config;
use anyhow::{Context, Result};
use rustfm_scrobble_proxy::Scrobbler;
use tracing::info;

pub fn get_scrobbler(config: &Config) -> Result<Scrobbler> {
    let mut scrobbler = Scrobbler::new(&config.api_key, &config.api_secret);
    scrobbler
        .authenticate_with_password(&config.username, &config.password)
        .context("failed to authenticate")?;

    info!(" successfully authenticated");

    return Ok(scrobbler);
}